import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;
class CheaterDetector {  // *.txt for example
	/**
	 * compare
	 */
	public static int compare(String fileName1, String fileName2){
		int total=0;
		File file1 = new File(fileName1);
		File file2 = new File(fileName2);
		if (file1.exists() && file2.exists()){
			String newLine1, newLine2;
			try{
				FileReader inFile1 = new FileReader(file1);
		        BufferedReader inStream1 = new BufferedReader(inFile1);
		        FileReader inFile2 = new FileReader(file2);
		        BufferedReader inStream2 = new BufferedReader(inFile2);
		        
		        newLine1 = inStream1.readLine();
		        newLine2 = inStream2.readLine();
		        while (newLine1!=null && newLine2!=null){
		        	int difference=newLine1.compareTo(newLine2);
		        	if(difference==0){
		        		total++;
		        		newLine1 = inStream1.readLine();
				        newLine2 = inStream2.readLine();
		        	}else if(difference<0){
		        		newLine1 = inStream1.readLine();
		        	}else newLine2 = inStream2.readLine();
		        }
		        
		        inFile1.close();
		        inStream1.close();
		        inFile2.close();
		        inStream2.close();
			}catch (IOException e){
	        	   System.out.println("Some dreadful file error occured");
	           }
		}
		return total;
	}
	/**
	 * sortFile 
	 */
	public static void sortFile(String fileName){
	   File dataFile = new File(fileName);
	 
       if (dataFile.exists())
       {
           ArrayList<String> list=new ArrayList<String>();
           try{
           FileReader inFile = new FileReader(dataFile);
           BufferedReader inStream = new BufferedReader(inFile);
           String newLine;
          
           newLine = inStream.readLine();
           
           while (newLine!=null){
               list.add(newLine);
               newLine = inStream.readLine();
            }
           inStream.close(); 
           inFile.close();
           String[] seqs=new String[1];
           seqs= list.toArray(seqs);
           Arrays.sort(seqs);
           FileWriter fw=new FileWriter (dataFile);
           BufferedWriter bw=new BufferedWriter(fw);
          
           for(String s:seqs) {
        	   bw.write(s+"\n");
        	   //System.out.println(s);
             }
           bw.close();
           fw.close();
           
           } catch (IOException e){
        	   System.out.println("Drat. I had trouble with the file "+fileName);
           }
       }
       
	}
	/**
	 * makeSeqFile will read in file fileName
	 * and make a new .seq file with sequences of 
	 * n words.
	 */
	public static int makeSeqFile(String d, String fileName, int n){
		int count=0;
		ArrayList<String> seq=new ArrayList<String>();
		File dataFile = new File(d+File.separator+fileName);
        if (dataFile.exists())
       {
           try{
        	   //Create Streams
           FileReader inFile = new FileReader(dataFile);
           BufferedReader inStream = new BufferedReader(inFile);
           String seqFileName = "seq_files"+File.separator;
           seqFileName+=fileName.substring(0, fileName.indexOf("."))+".seq";
           FileWriter fw=new FileWriter (seqFileName);
           BufferedWriter bw=new BufferedWriter(fw);//wrap basic object
           StreamTokenizer tok=new StreamTokenizer(inStream);
        // Tokenizer can't use java style default
           tok.resetSyntax();tok.wordChars(33,255);
           tok.whitespaceChars(0,' ');tok.eolIsSignificant(false);
           String word="";
           
           while ( tok.nextToken() != StreamTokenizer.TT_EOF)
           {
              switch (tok.ttype) //ttype is class property!
              {
              case StreamTokenizer.TT_WORD :word=tok.sval;break;
              //case StreamTokenizer.TT_NUMBER:word=String.valueOf(tok.nval);break;
              //case StreamTokenizer.TT_EOL:word="\n";break;
              default :word="~";break;
              }
              //bw.write(word + " ");
              count++;
              seq.add(word);
              if (count>=n) {
            	  for (String s:seq) bw.write(s+" ");
            	  bw.write("\n");
            	  seq.remove(0);
              }
           }
           bw.close();
           fw.close();
           inFile.close();
           inStream.close(); 
           
           } catch (IOException e){}
       }
        return count;
	}
	
	public static String[] getFileList(String d){
	  String dir="user.dir"; // set to current directory
	  try {dir=new File(System.getProperty(dir)).getCanonicalPath();}
	  catch (IOException e1) { /*handler required but null */ }
	  System.out.println ("Current dir : " + dir);
	      
	      String dirname=dir+File.separator+d;      // select directory
	    File f1 = new File(dirname);
	    FilenameFilter only = new OnlyExt("txt"); // and ext
	    return f1.list(only);    // array of files
  }
  private static int getUsersDirectoryChoice(){
	  Scanner kb=new Scanner(System.in);
	  int choice;
	  do{
		  System.out.println("Catch a Cheater!\nChoose 1, 2, or 3:");
		  System.out.println("\t1. sm_doc_set (25 documents)");
		  System.out.println("\t2. med_doc_set (75 documents)");
		  System.out.println("\t3. big_doc_set (500 documents)");	
		  System.out.println("\t4. huge_doc_set (1,355 documents)");	
		  choice=Integer.parseInt(kb.nextLine());
	  } while (choice<1 || choice>4);
	  return choice;
  }
  private static int getSequenceSize(){
	  Scanner kb=new Scanner(System.in);
	  int size;
		do{
			System.out.println("Compare sequences of how many words? (2-15)");
			
			size=Integer.parseInt(kb.nextLine());
			} while (size<2 || size>15);
		return size;
  }
  public static void main(String args[])
  {
	//get the User's selection
	int seqLength=getSequenceSize();
	int choice=getUsersDirectoryChoice();
	
	//initialze our data
	String directory="sm_doc_set";
	if (choice==2) directory="med_doc_set";
	if (choice==3) directory="big_doc_set";
	if (choice==4) directory="huge_doc_set";
	
    String[] fileNames=getFileList(directory);
    String[] seqFileNames=new String[fileNames.length];
    long time=System.currentTimeMillis();
    
    //create sequence files
    for (int i=0; i<fileNames.length; i++)
    { 
    	String n=fileNames[i].substring(0, fileNames[i].indexOf("."));
    	seqFileNames[i]="seq_files"+File.separator+n+".seq";
    	int count=makeSeqFile(directory, fileNames[i], seqLength);
    	System.out.println(fileNames[i]+" has "+count+" words");
    }
    //sort sequence files
    for(int i=0; i<seqFileNames.length;i++){
    	System.out.println("Sorting "+seqFileNames[i]);
        sortFile(seqFileNames[i]);
    }
        
    //compare two files, counting hits
    int comparisons=fileNames.length*(fileNames.length-1)/2;
    System.out.println(comparisons+" comparisons required");
    for(int i=0; i<fileNames.length-1; i++)
    	for (int j=i+1; j<fileNames.length; j++){
    	int total=compare(seqFileNames[i], seqFileNames[j]);
    	//Comment the line below to speed up execution
    	if (total>0)
    		System.out.println("Score for "+ fileNames[i]+" and "+fileNames[j] +" is "+total);
    	/**
    	 *  Insert your code here to store score information
    	 */
    }
    
    //report findings
    time=System.currentTimeMillis()-time;
    System.out.println(fileNames.length+" files took "+time+" milliseconds.");
    /**
     * Insert your code here to Display your
     * sorted scores
     */
  }
}